<?php

namespace App\Tasks\MassInsert;

use App\Models\Transaction;
use Carbon\Carbon;
use Illuminate\Support\Facades\DB;

class MassInsert5Task
{

    /**
     * insert unit block with transaction
     *
     *    1000 - Database\Seeders\TransactionSeeder ......   380.20 ms DONE
     *   10000 - Database\Seeders\TransactionSeeder .....  3,716.59 ms DONE
     *  100000 - Database\Seeders\TransactionSeeder ....  39,143.04 ms DONE
     * 1000000 -
     *
     * 1. insert into transactions (id, value, date) values (1, 10, '2023-04-01');
     * 2. insert into transactions (id, value, date) values (2, 20, '2023-04-02');
     * .... 1.000 commit
     * - reconstroi os indices, verifica chave, view materializada
     *
     * 1001. insert into transactions (id, value, date) values (1, 10, '2023-04-01');
     * 1002. insert into transactions (id, value, date) values (2, 20, '2023-04-02');
     * .... 1.000 commit
     * - reconstroi os indices, verifica chave, view materializada
     *
     */
    public function handle(int $count): void
    {
        $block = 1000;
        while ($count > 0) {

            if ($count < $block) {
                $block = $count;
            }

            DB::beginTransaction();
            try {
                Transaction::factory($block)->create();

                DB::commit();
                $count -= $block;
            } catch (\Exception $exception) {
                DB::rollBack();
            }
        }
    }
}
