<?php

namespace App\Tasks\MassUpdate\Group1;

use App\Models\Transaction;
use Carbon\Carbon;

class MassUpdate2Task
{
    /**
     * Atualiza o campo data e valor, mas passando todos os ids das transações,
     * Atualizando com where id in(1,2,3...).
     *
     *    1000 ...... 19.87ms DONE
     *   10000 ..... 149.19ms DONE
     *  100000 ........... 1s DONE
     * 1000000 .......... 15s DONE
     */
    public function handle()
    {
        Transaction::query()
            ->select([
                'id',
            ])
            ->where('id', '>', 0)
            ->chunkById(1000, function ($transactions) {
                Transaction::query()
                    ->whereIn('id', $transactions->pluck('id'))
                    ->update([
                        'date' => Carbon::now(),
                        'value' => 1,
                    ]);
            });
    }
}
